define([
    'text!./index.html',
    'css!./index.css'
], function (html) {
    return {
        props: {
            publicData: {
                type: Object,
                default: function () {
                    return {};
                }
            }
        },
        data: function () {
            return {
                year: new Date().getFullYear(),
                code_url: '',
                sidebarHeight: 0
            };
        },
        mounted: function () {
            this.$nextTick(function () {
                if (code_url) {
                    this.code_url = code_url;
                }
            });               
        },
        updated: function () {
            this.$nextTick(function () {
                this.sidebarHeight = this.$refs.sidebar.clientHeight;
                this.$emit('action', this.$refs.sidebar.clientHeight);
            });
        },
        methods: {
            goPage: function () {
                window.useCustomerServer.getCustomeServer();
            }
        },
        template: html
    };
});